'''
text.py - class Text for in-world text object

not done; existing uses are experimental and broken;
further development awaits:
- command line, so we can give a command to create one, e.g. "add sign", or to move one (attach? move? select?)
- more systematic save/load formatting
- change shape interface to iter over all vertex lists, not depend on shape.vertex_list;
  - perhaps a more general way to change what graphical contents something has
- be able to make it an IncrementalTextLayout 
'''

from pyglet.gl import *
import pyglet

from movable import Movable

from constants import ORIGIN

class TextGroup(pyglet.graphics.Group): # note: client code must use this, we don't use it herein
    "encapsulate GL state leakage caused by bugs(?) in pyglet.text.Label"
    def set_state(self):
        glPushAttrib(GL_TEXTURE_BIT) # prevents leakage of change to texture clamping
    def unset_state(self):
        glPopAttrib()
    pass

class _TextShape: # kluge, I guess -- something to wait for an add_to_batch call before creating the Label
    def __init__(self, desc = None):
        self.desc = desc
    def add_to_batch(self, batch, group):
        # XXX use self.desc, if not None
        print "_TextShape desc", self.desc
        self._label = pyglet.text.Label("abcd", x = 0, y = 0, anchor_y = 'bottom', batch = batch, group = group)
    # XXX change shape interface to iter over all vertex lists, rather than have one .vertex_list attr as now;
    # then a std remove_from_batch on our client (has us as .shape) should work... unless it needs to call a
    # remove or delete method directly on self._label
    def get_desc(self):
        # note: unlike for a HasDesc subclass, we have no superclass info in [0]
        label = self._label
        return ( label.text, label.x, label.y ) #### @@@ map ord over self.text; add or modify fields; need quat in movable desc 
    pass

class Text(Movable):
    def __init__(self, desc = None, initpos = ORIGIN):
        Movable.__init__(self, initpos = initpos, desc = desc and desc[0])
        self.shape = _TextShape(desc = desc and desc[1])
    def get_desc(self):
        return (
            Movable.get_desc(self),
            self.shape.get_desc(),
         )
    pass

