'''
utilities.py

simple utilities; safe for import *
'''

if __name__ == '__main__':
    # for standalone testing, when run from this modules's directory
    import sys
    sys.path.insert(0, "../lib/pyeuclid") # for import euclid
    sys.path.insert(0, "../lib") # for import pyglet


from math import atan2

from pyglet.window import key as _key

OPTION_KEYS = ( _key.LOPTION, _key.ROPTION, _key.LALT, _key.RALT, )


def option_key_pressed(keyboard):
    for keycode in OPTION_KEYS:
        if keyboard[keycode]: # not 'in', that's fooled by explicit False value
            return True
    return False


def heading_to_angle(x,y):
    # see http://docs.python.org/library/math.html ... digr: other math functions to know about: hypot, degrees, radians...
    return atan2(y, x)




# ==

if __name__ == '__main__':
    # test heading_to_angle
    for a0 in range(16):
        a = a0 - 8 # -8 to 7
        a /= 8. # -1 to almost 1
        a *= pi # most angles in radians
        # a is angle, now compute heading as tuple (x,y)
        h = cos(a), sin(a)
        # now reverse this with heading_to_angle
        a2 = heading_to_angle(h[0], h[1])
        # now see if we got that right to 6 digits
        assert abs(a2 - a) < 0.000001, "a = %r, h = %r, a2 = %r should equal a" % (a,h,a2)
    print "tests done: heading_to_angle"

